; xors.asm xorPattern, in Pila, for Palm m100

	appl "xorsAsm",'demo'

	include "pilot.inc"
	include "startup.inc"

; TODO: hardware-reg equ file...
; LCD controller regs
rLPICF 	equ $A20
rLVPW  	equ $A05
rLSSA	equ $A00

dREG equ $FFFFF000 ; DragonBall regs

	code

proc PilotMain(cmd.w, cmdPBP.l, launchFlags.w)
; func args are equ'd as offsets from 'a6' reg
local err.w
local evt.EventType
local oldScreen.l
; and so are 'local's
beginproc
; ^ does 'link a6,#nnnn', for after args/locals
	tst.w cmd(a6)
	bne .Return ; sysAppLaunchCmdNormalLaunch is 0, else, quit

	move.l #dREG,a2

	or.b #$02,rLPICF(a2)
	lea rLVPW(a2),a1
	move.b (a1),d0
	lsl.b #2,d0
	move.b d0,(a1)

	move.l rLSSA(a2),oldScreen(a6)

	systrap MemPtrNew(#12800.l)
	; result in a0
;	move.l #dREG,a2

	move.l a0,rLSSA(a2)          ; and set in hardware

; memSet: (CLS)
	move.w #(160*80-1),d4
	move.b #$0f,d3
.l0
	move.b d3,(a0)+
	dbra d4,.l0

;	bra .eventLoop

	move.l dREG|rLSSA,a0          ;  re-read screen pointer
	move.w #160-1,d4
.y
	move.w #$A0-1,d3
.x
	move.b d3,d2
	eor.b d4,d2
	lsl.b #4,d2
	subq.b #1,d3
	move.b d3,d1
	eor.b d4,d1
	and.b #$0f,d1
	or.b d2,d1
	move.b d1,(a0)+
	dbra d3,.x
	dbra d4,.y

.eventLoop
	systrap EvtGetEvent(&evt(a6), #evtWaitForever.w)
	systrap SysHandleEvent(&evt(a6))
	tst.b   d0                      ;handled?
	bne.s   .eventDone             ;yep

	nop ; can't branch to next instr

;        call    weHandleEvent(&evt(a6))
;        tst.b   d0                      ;handled?
;        bne.s   .eventDone             ;yep
.eventDone
	cmpi.w  #appStopEvent,evt+EventType.eType(a6) ;time to stop?
	bne.s   .eventLoop             ;nope, loop until it is

	move.l #dREG,a2
	and.b #$fc,rLPICF(a2)
	lea rLVPW(a2),a1
	move.b (a1),d0
	lsr.b #2,d0
	move.b d0,(a1)

	move.l oldScreen(a6),rLSSA(a2)

.Return:
	moveq.l   #0,d0
endproc ; PilotMain

; Must have pref resources (otherwise 'fatal-error', on hotsync even!)
	res	'tver', 1
	dc.b	'1.0', 0

	res	'pref', 1
	dc.w	sysAppLaunchFlagNewStack|sysAppLaunchFlagNewGlobals|sysAppLaunchFlagUIApp|sysAppLaunchFlagSubCall
	dc.l	$1000			; stack size
	dc.l	$1000			; heap size


