/* mand2.c */
/* mandelbrot-set-plot
some code taken from 'lcd16gry'
 license: GPL
 */
Byte *LPICF = (Byte *) 0xFFFFFA20;
Byte *LVPW = (Byte *) 0xFFFFFA05;
ULong *LSSA=(ULong *) 0xFFFFFA00;

#define minn(a,b) (a)=(a)<(b)?(a):(b)
#define maxx(a,b) (a)=(a)>(b)?(a):(b)
#define MIN(a,b) (a)<(b)?(a):(b)
#define MAX(a,b) (a)>(b)?(a):(b)

char *screen;

void pix(int x, int y,char c);

long cr0,ci0,cr,ci,a,b,a2,b2;
long dx,dy;
char weSqr;
void drawMand(void) {
int x,y;char col;
 ci=ci0;
 for (y=0;y<160;++y){
  cr=cr0;
  for (x=0;x<160;++x){
   a=0;b=0;col=0;
   do {
    a2=a*a;b2=b*b;
    a2>>=10;b2>>=10;
//    b=(a>>5)*(b>>4)+ci;
    b=((a*b)>>9)+ci;
    a=a2-b2+cr;
   }while((col++<16)&&
	(a2+b2<(4<<10)));
	pix(x,y,col<<0);
	cr+=dx;
  }
  ci+=dy;
 }
}

EventType e;
Err error;
void (*handleEvents)(void);

int minX,maxX,minY,
 maxY,x,y;

int pointInRect(int x,int y,int x0,int y0,
 int x1,int y1) {
 return (x>=x0&x<=x1&y>=y0&y<=y1);

}

void pix(int x, int y,char c) {
 char*addr=screen+(x>>1)+(y<<4)+(y<<6);
 if(x&1) {
  *addr&=0xf0;
  *addr|=c;
 } else {
  *addr&=0x0f;
  *addr|=c<<4;
 }
}

//twoPixframNicrNfastr
void xorSqr(int x0,int y0,
  int x1,int y1) {
 if (x0>x1) {xorSqr(x1,y0,x0,y1); return;}
 if (y0>y1) {xorSqr(x0,y1,x1,y0); return;}
 char*p0=screen+(y0<<4)+(y0<<6);
 char*p1=p0;
 x0>>=1;x1>>=1;
 p0+=x0;p1+=x1;
 for(y=y1-y0;y;--y){
  *p0=~*p0;*p1=~*p1;
  p0+=80;p1+=80;
 }
 p0=screen+(y0<<4)+(y0<<6)+x0;
 p1=screen+(y1<<4)+(y1<<6)+x0;
 for(x=x1-x0;x;--x){
  *p0=~*p0;*p1=~*p1;
  ++p0;++p1;
 }
}

void h1(void);

//mark minMaxSketch handler
void h0(void){
switch (e.eType) {
 case keyDownEvent:
   switch (e.data.keyDown.chr) {
   case pageDownChr:
 // zoom out to fullview?
     break;
   case pageUpChr:
 // zoom out x2?
     break;
   default:
     break;
   }
 break;

 case penDownEvent:
  xorSqr(minX,minY,maxX,maxY);
  minX=e.screenX; maxX=e.screenX;
  minY=e.screenY; maxY=e.screenY;
  break;

 case penMoveEvent:
  minn(minX,e.screenX);maxx(maxX,e.screenX);
  minn(minY,e.screenY);maxx(maxY,e.screenY);
  break;

 case penUpEvent:
  minn(minX,e.screenX);maxx(maxX,e.screenX);
  minn(minY,e.screenY);maxx(maxY,e.screenY);
  xorSqr(minX,minY,maxX,maxY);
  handleEvents=h1;
  break;

 default:
  break;

 }
}

// 'drag' mode handler
void h1(void){
switch (e.eType) {
 case keyDownEvent:
   switch (e.data.keyDown.chr) {
   case pageDownChr:
 // zoom out to fullview?
     break;
   case pageUpChr:
 // zoom out x2?
     break;
   default:
     break;
   }
 break;

 case penDownEvent:
  x=e.screenX; y=e.screenY;
  if (!pointInRect(x,y,minX,minY,maxX,maxY)) {
   handleEvents=h0;
   h0();
   return;
  }
  // zoom into region:
  cr0 += minX*dx; ci0 += minY*dy;
if (weSqr){
  Long maxD=MAX(maxX-minX,maxY-minY);
 dx*=maxD; dy*=maxD;
 } else {
  dx *= (maxX-minX);
  dy *= (maxY-minY);
}
  dx/=160; dy/=160;
  drawMand();
  minX=0,maxX=0,minY=0,maxY=0;
  handleEvents=h0;
  return;
  break;

 case penMoveEvent:
  break;

 case penUpEvent:
  break;

 default:
  break;

 }
}



DWord PilotMain(Word cmd, Ptr cmdPBP, Word launchFlags) {
 handleEvents=h0;
 minX=0,maxX=0,minY=0,maxY=0;
 cr0=-2<<10,ci0=-2<<10;
 dy=(3<<10)/160,dx=(3<<10)/160;
 weSqr=1;
 if (cmd == sysAppLaunchCmdNormalLaunch) {
 ULong loc;
 loc =*LSSA;
 screen = MemPtrNew(12800);
// MemSet(screen, 12800, 0xff);
 *LPICF |= 0x02;
 *LVPW <<= 2;
 *LSSA =(ULong)screen;

/* draw Mand: */
if(1)
 drawMand();

 do {
  EvtGetEvent(&e, evtWaitForever);
  if (SysHandleEvent(&e))
	continue;

  handleEvents();
 } while (e.eType != appStopEvent);


 *LSSA = loc;
 *LVPW >>= 2;
 *LPICF &= 0xFC;

 }
 return 0;
}

